//===========================================================================
//  $Name: arts++-1-1-a5 $
//  $Id: ArtsPortTableAggregatorMapKey.hh,v 1.1 1998/09/18 08:20:46 dwm Exp $
//===========================================================================
//  CAIDA Copyright Notice
//
//  By accessing this software, arts++, you are duly informed
//  of and agree to be bound by the conditions described below in this
//  notice:
//
//  This software product, arts++, is developed by Daniel W. McRobb, and
//  copyrighted(C) 1998 by the University of California, San Diego
//  (UCSD), with all rights reserved.  UCSD administers the CAIDA grant,
//  NCR-9711092, under which part of this code was developed.
//
//  There is no charge for arts++ software. You can redistribute it
//  and/or modify it under the terms of the GNU General Public License,
//  v.  2 dated June 1991 which is incorporated by reference herein.
//  arts++ is distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
//  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use
//  of it will not infringe on any third party's intellectual property
//  rights.
//
//  You should have received a copy of the GNU GPL along with arts++.
//  Copies can also be obtained from:
//
//    http://www.gnu.org/copyleft/gpl.html
//
//  or by writing to:
//
//    University of California, San Diego
//
//    SDSC/CAIDA
//    9500 Gilman Dr., MS-0505
//    La Jolla, CA 92093 - 0505  USA
//
//  Or contact:
//
//    info@caida.org
//===========================================================================

#ifndef _ARTSPORTTABLEAGGREGATORMAPKEY_HH_
#define _ARTSPORTTABLEAGGREGATORMAPKEY_HH_

extern "C" {
#include "caida_t.h"
}

//---------------------------------------------------------------------------
//  class ArtsPortTableAggregatorMapKey
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class ArtsPortTableAggregatorMapKey
{
public:
  //-------------------------------------------------------------------------
  //                     inline ipv4addr_t Router() const                    
  //.........................................................................
  //  
  //-------------------------------------------------------------------------
  inline ipv4addr_t Router() const
  {
    return(this->_router);
  }
  
  //-------------------------------------------------------------------------
  //                   ipv4addr_t Router(ipv4addr_t router)                  
  //.........................................................................
  //  
  //-------------------------------------------------------------------------
  ipv4addr_t Router(ipv4addr_t router)
  {
    this->_router = router;
    return(this->_router);
  }
  
  //-------------------------------------------------------------------------
  //                         uint16_t IfIndex() const                        
  //.........................................................................
  //  
  //-------------------------------------------------------------------------
  uint16_t IfIndex() const
  {
    return(this->_ifIndex);
  }
  
  //-------------------------------------------------------------------------
  //                    uint16_t IfIndex(uint16_t ifIndex)                   
  //.........................................................................
  //  
  //-------------------------------------------------------------------------
  uint16_t IfIndex(uint16_t ifIndex)
  {
    this->_ifIndex = ifIndex;
    return(this->_ifIndex);
  }

  //-------------------------------------------------------------------------
  // inline bool operator < (const ArtsPortTableAggregatorMapKey & key) const 
  //.........................................................................
  //  
  //-------------------------------------------------------------------------
  inline bool operator < (const ArtsPortTableAggregatorMapKey & key) const
  {
    if (this->_router < key.Router())
      return(true);
    if (this->_router > key.Router())
      return(false);

    if (this->_ifIndex < key.IfIndex())
      return(true);

    return(false);
  }
  
private:
  ipv4addr_t  _router;
  uint16_t    _ifIndex;
};

#endif  // _ARTSPORTTABLEAGGREGATORMAPKEY_HH_
